Letter currentLetter;
Letter previousLetter;
Letter[] alphabet;
color defaultColor = color(0,0,0);
int defaultSize = 20;
int maxSize = 100;
float circleRadius = 400.0;

void setup() {
  size(displayWidth, displayHeight);
  PVector center = new PVector(width/2 - 30, height/2 - 30);
  background(0);
  frameRate(60);
  
  //initialisation de l'alphabet
  alphabet = new Letter[0];
  char c = 'a';
  for (int i = 0; i < 26; i++) {
    Letter l = new Letter(c);
    l.setColor(defaultColor);
    l.setSize(defaultSize);
    float deg = float(i);
    PVector p = new PVector(center.x + circleRadius * cos(deg * TWO_PI/26.0), center.y + circleRadius * sin(deg * TWO_PI/26.0));
    l.setPosition(p);
    alphabet = (Letter[]) append(alphabet, l);
    c++;
  }
  
  currentLetter = new Letter();
  previousLetter = new Letter();
}

void draw() {
  background(0);
  if (keyPressed) {
    previousLetter = currentLetter;
    checkKey();
    updateCurrent();
    //tap(currentLetter);
  }
  drawLinks(alphabet);
  drawLetters(alphabet);
  println("current letter is", currentLetter.getKey(), "previous letter was", previousLetter.getKey());
  delay(100);
} 

void delay(int d) {
 int time = millis();
 while(millis() - time <= d); 
}

void checkKey() {
  Letter l;
    for (int i = 0; i < alphabet.length; i++) {
      l = alphabet[i];
      if (key == l.getKey()) {
        currentLetter = l;
      }
    }
}

void tap(Letter l) {
  PVector p = l.getPosition();
  color c = l.getColor();
  fill(c);
  noStroke();
  ellipse(p.x, p.y, 20, 20);
}

void updateCurrent() {
  Letter l = currentLetter;
  l.addLink(previousLetter);
  l.hit();
  setLetterColor(l);
  setSize(l);
}

void setLetterColor(Letter l) {
  PVector col = l.getColorVector();
  PVector newCol = new PVector(col.x, col.y, col.z);
  int diff = 50;
  if (col.x == 0 && col.y >= 0 && col.z == 0) {
    newCol.y = col.y + diff;
    if (newCol.y > 255)
      newCol.y = 255;
  }
  if (col.x == 0 && col.y == 255 && col.z >= 0) {
    newCol.z = col.z + diff;
    if (newCol.z > 255)
     newCol.z = 255;
  }
  if (col.x == 0 && col.y >= 0 && col.z == 255) { 
    newCol.y = col.y - diff; 
    if (newCol.y < 0)
      newCol.y = 0;
  }
  if (col.x >= 0 && col.y == 0 && col.z == 255) {
    newCol.x = col.x + diff;
    if (newCol.x > 255)
      newCol.x = 255;
  }
  if (col.x == 255 && col.y == 0 && col.z >=0) {
    newCol.z = col.z - diff;
    if (newCol.z < 0)
      newCol.z = 0;
  }
  l.setColorVector(newCol);
  l.setColor(color(newCol.x, newCol.y, newCol.z));
}

void setSize(Letter l) {
  int s = l.getSize();
  int newS = s;
  int diff = 5;
  if (s < maxSize) {
    newS += diff;
  }
  l.setSize(newS);
}

void drawLetters(Letter[] alphabet) {
  int len = alphabet.length;
  for (int i = 0; i<len; i++) {
    Letter l = alphabet[i];
    color c = l.getColor();
    int s = l.getSize();
    PVector p = l.getPosition();
    fill(c);
    noStroke();
    ellipse(p.x, p.y, s, s);
  }
}

void drawLinks(Letter[] alphabet) {
  int len = alphabet.length;
  for (int i = 0; i<len; i++) {
    Letter l = alphabet[i];
    Letter[] links = l.getLinks();
    int numlinks = links.length;
    for (int j = 0; j<numlinks; j++) {
      Letter l2 = links[j];
      PVector pos1 = l.getPosition();
      PVector pos2 = l2.getPosition();
      stroke(l.getColor());
      line(pos1.x, pos1.y, pos2.x, pos2.y);
    }
  }
}


